'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var useWakeLock = function useWakeLock() {
  var _useState = react.useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      wakeLock = _useState2[0],
      setWakeLock = _useState2[1];

  var _useState3 = react.useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      wakeLockActive = _useState4[0],
      setWakeLockActive = _useState4[1];

  var _useState5 = react.useState(""),
      _useState6 = _slicedToArray(_useState5, 2),
      wakeLockError = _useState6[0],
      setWakeLockError = _useState6[1];

  var _useState7 = react.useState(null),
      _useState8 = _slicedToArray(_useState7, 2),
      timer = _useState8[0],
      setTimer = _useState8[1];

  react.useEffect(function () {
    return function () {
      return timer && clearTimeout(timer);
    };
  }, [timer]);

  var cleanup = function cleanup() {
    setWakeLock(null);
    setWakeLockActive(false);
    setWakeLockError("");
  };

  var toggleWakeLock = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var duration,
          tempWakeLock,
          tempTimer,
          _args = arguments;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              duration = _args.length > 0 && _args[0] !== undefined ? _args[0] : 0;

              if (!(typeof duration !== "number")) {
                _context.next = 3;
                break;
              }

              throw Error("Duration must be a number");

            case 3:
              if (wakeLockActive) {
                _context.next = 20;
                break;
              }

              _context.prev = 4;
              _context.next = 7;
              return window.navigator.wakeLock.request("screen");

            case 7:
              tempWakeLock = _context.sent;

              if (duration !== 0) {
                tempTimer = setTimeout(function () {
                  tempWakeLock.release();
                  cleanup();
                }, duration);
                setTimer(tempTimer);
              }

              setWakeLock(tempWakeLock);
              setWakeLockActive(true);
              setWakeLockError("");
              _context.next = 18;
              break;

            case 14:
              _context.prev = 14;
              _context.t0 = _context["catch"](4);
              setWakeLockError("".concat(_context.t0.name, ", ").concat(_context.t0.message));
              console.error("".concat(_context.t0.name, ", ").concat(_context.t0.message));

            case 18:
              _context.next = 22;
              break;

            case 20:
              // Release wake lock
              wakeLock.release();
              cleanup();

            case 22:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[4, 14]]);
    }));

    return function toggleWakeLock() {
      return _ref.apply(this, arguments);
    };
  }();

  return {
    toggleWakeLock: toggleWakeLock,
    wakeLockActive: wakeLockActive,
    wakeLockError: wakeLockError
  };
};

exports.useWakeLock = useWakeLock;
//# sourceMappingURL=index.js.map
